on initPuzzle
  global difficultyLevel, csrChannel, numTiles, tileStartCh, drag1Ch, drag2Ch, tileColors, tileFacing, tileOrientation, orientationIndex, puzzleNum, hideCursor, puzzleActive
  clearVars(1)
  set difficultyLevel to 2
  installMenu(cast "JEWEL menu")
  if the windowList = EMPTY then
  end if
  set hideCursor to 0
  set puzzleActive to 1
  set puzzleNum to 19
  set numTiles to 9
  set tileStartCh to 2
  set drag1Ch to 45
  set drag2Ch to 44
  set tileOrientation to [[1, 2, 1, 2], [1, 3, 1, 3], [4, 3, 4, 3], [4, 2, 4, 2]]
  repeat with a = tileStartCh to tileStartCh + numTiles - 1
    puppetSprite(a, 1)
    set the immediate of sprite a to 1
  end repeat
  set the immediate of sprite drag1Ch to 1
  set the visible of sprite drag1Ch to 0
  set the constraint of sprite drag1Ch to 46
  if difficultyLevel = 1 then
    set tileCast to ["1.0", "2.0", "3.0", "4.0", "5.0", "6.0", "7.0", "8.0", "9.0"]
  else
    if difficultyLevel = 2 then
      set tileCast to ["1.3", "9.9", "6.9", "3.9", "4.6", "5.3", "8.6", "2.6", "7.3"]
    end if
  end if
  repeat with a = 1 to 9
    preLoadCast(the number of cast getAt(tileCast, a))
  end repeat
  resetPuzzle()
end

on resetPuzzle
  global difficultyLevel, numTiles, tileStartCh, drag1Ch, tileColors, tileFacing, tileOrientation, orientationIndex
  if difficultyLevel = 1 then
    set tileColors to [[2, 3, 1, 3], [2, 2, 2, 3], [1, 3, 2, 2], [1, 2, 1, 3], [3, 2, 2, 2], [2, 3, 1, 2], [2, 2, 1, 3], [1, 2, 2, 2], [2, 1, 2, 3]]
    set tileFacing to [[1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2], [1, 2, 1, 2]]
    set orientationIndex to [1, 1, 1, 1, 1, 1, 1, 1, 1]
    set tileCast to ["6.0", "8.0", "7.0", "5.0", "4.0", "9.0", "3.0", "1.0", "2.0"]
  else
    if difficultyLevel = 2 then
      set tileColors to [[2, 1, 2, 2], [3, 1, 2, 2], [3, 1, 3, 2], [2, 1, 3, 2], [2, 2, 3, 2], [3, 1, 2, 1], [2, 3, 2, 2], [2, 3, 2, 1], [2, 1, 3, 2]]
      set tileFacing to [[1, 3, 1, 3], [4, 2, 4, 2], [4, 2, 4, 2], [4, 2, 4, 2], [4, 3, 4, 3], [1, 3, 1, 3], [4, 3, 4, 3], [4, 3, 4, 3], [1, 3, 1, 3]]
      set orientationIndex to [2, 4, 4, 4, 3, 2, 3, 3, 2]
      set tileCast to ["1.3", "9.9", "6.9", "3.9", "4.6", "5.3", "8.6", "2.6", "7.3"]
    end if
  end if
  repeat with a = 1 to numTiles
    set the castNum of sprite (tileStartCh + a - 1) to the number of cast getAt(tileCast, a)
    updateCursor()
  end repeat
end

on swapChannel chA, chB
  set the locH of sprite chA to the locH of sprite chB
  set the locV of sprite chA to the locV of sprite chB
  set the castNum of sprite chA to the castNum of sprite chB
  set the visible of sprite chA to 1
  set the visible of sprite chB to 0
end

on swapTileParameters tileACh, tileBCh
  global tileColors, tileFacing, orientationIndex
  set tempA to getAt(tileColors, tileACh - 1)
  set tempB to getAt(tileColors, tileBCh - 1)
  setAt(tileColors, tileACh - 1, tempB)
  setAt(tileColors, tileBCh - 1, tempA)
  set tempA to getAt(tileFacing, tileACh - 1)
  set tempB to getAt(tileFacing, tileBCh - 1)
  setAt(tileFacing, tileACh - 1, tempB)
  setAt(tileFacing, tileBCh - 1, tempA)
  set tempA to getAt(orientationIndex, tileACh - 1)
  set tempB to getAt(orientationIndex, tileBCh - 1)
  setAt(orientationIndex, tileACh - 1, tempB)
  setAt(orientationIndex, tileBCh - 1, tempA)
end

on turnTile whichTile, direction
  global tileColors, tileFacing, tileOrientation, orientationIndex, drag1Ch
  if direction = -1 then
    set savedElement to 4
  else
    set savedElement to 1
  end if
  set tempColor to getAt(getAt(tileColors, whichTile - 1), savedElement)
  if direction = -1 then
    repeat with a = 4 down to 2
      setAt(getAt(tileColors, whichTile - 1), a, getAt(getAt(tileColors, whichTile - 1), a - 1))
    end repeat
  else
    repeat with a = 1 to 3
      setAt(getAt(tileColors, whichTile - 1), a, getAt(getAt(tileColors, whichTile - 1), a + 1))
    end repeat
  end if
  setAt(getAt(tileColors, whichTile - 1), 5 - savedElement, tempColor)
  set a to getAt(orientationIndex, whichTile - 1)
  set a to a - (direction * 1)
  if a = 5 then
    set a to 1
  else
    if a = 0 then
      set a to 4
    end if
  end if
  setAt(orientationIndex, whichTile - 1, a)
  setAt(tileFacing, whichTile - 1, getAt(tileOrientation, a))
  set tempName to the name of cast the castNum of sprite whichTile
  set x to value(char offset(".", tempName) + 1 to length(tempName) of tempName)
  set tempName to char 1 to offset(".", tempName) of tempName
  swapChannel(drag1Ch, whichTile)
  puppetSound("Rotate Tile")
  updateCursor()
  if direction = -1 then
    repeat with a = 1 to 4
      set the castNum of sprite drag1Ch to the number of cast (tempName & string(x))
      updateCursor()
      startTimer()
      repeat while the timer <= 10
      end repeat
      set x to x + 1
      if x > 11 then
        set x to 0
      end if
    end repeat
  else
    repeat with a = 4 down to 1
      set the castNum of sprite drag1Ch to the number of cast (tempName & string(x))
      updateCursor()
      startTimer()
      repeat while the timer <= 10
      end repeat
      set x to x - 1
      if x < 0 then
        set x to 11
      end if
    end repeat
  end if
  swapChannel(whichTile, drag1Ch)
  updateCursor()
end

on checkPuzzle
  global tileColors, tileFacing, solvedPuzzles, puzzleNum
  if getAt(getAt(tileColors, 1), 3) <> getAt(getAt(tileColors, 2), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 2), 3) <> getAt(getAt(tileColors, 3), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 4), 3) <> getAt(getAt(tileColors, 5), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 5), 3) <> getAt(getAt(tileColors, 6), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 7), 3) <> getAt(getAt(tileColors, 8), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 8), 3) <> getAt(getAt(tileColors, 9), 1) then
    exit
  end if
  if getAt(getAt(tileColors, 1), 4) <> getAt(getAt(tileColors, 4), 2) then
    exit
  end if
  if getAt(getAt(tileColors, 2), 4) <> getAt(getAt(tileColors, 5), 2) then
    exit
  end if
  if getAt(getAt(tileColors, 3), 4) <> getAt(getAt(tileColors, 6), 2) then
    exit
  end if
  if getAt(getAt(tileColors, 4), 4) <> getAt(getAt(tileColors, 7), 2) then
    exit
  end if
  if getAt(getAt(tileColors, 5), 4) <> getAt(getAt(tileColors, 8), 2) then
    exit
  end if
  if getAt(getAt(tileColors, 6), 4) <> getAt(getAt(tileColors, 9), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 1), 3) <> getAt(getAt(tileFacing, 2), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 2), 3) <> getAt(getAt(tileFacing, 3), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 4), 3) <> getAt(getAt(tileFacing, 5), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 5), 3) <> getAt(getAt(tileFacing, 6), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 7), 3) <> getAt(getAt(tileFacing, 8), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 8), 3) <> getAt(getAt(tileFacing, 9), 1) then
    exit
  end if
  if getAt(getAt(tileFacing, 1), 4) <> getAt(getAt(tileFacing, 4), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 2), 4) <> getAt(getAt(tileFacing, 5), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 3), 4) <> getAt(getAt(tileFacing, 6), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 4), 4) <> getAt(getAt(tileFacing, 7), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 5), 4) <> getAt(getAt(tileFacing, 8), 2) then
    exit
  end if
  if getAt(getAt(tileFacing, 6), 4) <> getAt(getAt(tileFacing, 9), 2) then
    exit
  end if
  if the windowList = [] then
    puppetSound("WELLRTN.SND", 1)
    updateStage()
  else
    tell the stage
      puzzleDone()
    end tell
    updateCursor()
  end if
end

on doLoads
  global difficultyLevel, numTiles
  if the windowList = [] then
    set difficultyLevel to 2
  end if
  preLoadCast(the number of cast "1.0", the number of cast "9.11")
end

on renameCast
  set theCast to 1
  repeat with a = 1 to 9
    repeat with b = 0 to 11
      set tempName to string(a) & "." & string(b)
      set the name of cast theCast to tempName
      set theCast to theCast + 1
    end repeat
  end repeat
end
