on mouseDown
  global difficultyLevel, startPt, drag1Ch
  set mouseX to the mouseH
  set mouseY to the mouseV
  set startPt to point(the locH of sprite the clickOn, the locV of sprite the clickOn)
  set deltaX to mouseX - getAt(startPt, 1)
  set deltaY to mouseY - getAt(startPt, 2)
  swapChannel(drag1Ch, the clickOn)
  updateCursor()
  repeat while the mouseDown
    if rollOver(drag1Ch) = 0 then
      set deltaX to 0
      set deltaY to 0
    end if
    set the locH of sprite drag1Ch to the mouseH - deltaX
    set the locV of sprite drag1Ch to the mouseV - deltaY
    updateCursor()
  end repeat
end

on mouseUp
  global numTiles, tileStartCh, startPt, drag1Ch, drag2Ch
  if rollOver(drag1Ch) = 0 then
    swapChannel(the clickOn, drag1Ch)
  end if
  set rLeft to getAt(the clickLoc, 1) - 5
  set rTop to getAt(the clickLoc, 2) - 5
  set rRight to rLeft + 10
  set rBottom to rTop + 10
  set turnRect to rect(rLeft, rTop, rRight, rBottom)
  if inside(point(the mouseH, the mouseV), turnRect) then
    set a to the left of sprite the clickOn
    if the mouseH <= (a + (the width of sprite the clickOn / 2)) then
      set direction to 1
    else
      set direction to -1
    end if
    turnTile(the clickOn, direction)
    checkPuzzle()
    exit
  end if
  set releasePt to point(the mouseH, the mouseV)
  if the clickLoc = releasePt then
    swapChannel(the clickOn, drag1Ch)
    updateCursor()
    exit
  end if
  set snapToNewLocation to 0
  repeat with theTile = tileStartCh to tileStartCh + numTiles - 1
    if (theTile <> the clickOn) and inside(releasePt, the rect of sprite theTile) then
      set snapToNewLocation to 1
      exit repeat
    end if
  end repeat
  if snapToNewLocation = 1 then
    set endPt to point(the locH of sprite theTile, the locV of sprite theTile)
    swapTile(theTile, endPt, snapToNewLocation)
    swapChannel(drag1Ch, the clickOn)
    set the locH of sprite drag1Ch to getAt(endPt, 1)
    set the locV of sprite drag1Ch to getAt(endPt, 2)
    swapChannel(the clickOn, drag1Ch)
    puppetSound("Click Tile")
    updateStage()
    set tempSprite to the castNum of sprite the clickOn
    set the castNum of sprite the clickOn to the castNum of sprite theTile
    set the castNum of sprite theTile to tempSprite
    set tempX to the locH of sprite the clickOn
    set tempY to the locV of sprite the clickOn
    set the locH of sprite the clickOn to the locH of sprite theTile
    set the locV of sprite the clickOn to the locV of sprite theTile
    set the locH of sprite theTile to tempX
    set the locV of sprite theTile to tempY
    swapTileParameters(the clickOn, theTile)
    checkPuzzle()
  else
    set theTile to the clickOn
    set endPt to point(the locH of sprite drag1Ch, the locV of sprite drag1Ch)
    swapTile(theTile, endPt, snapToNewLocation)
  end if
end

on swapTile theTile, endPt, snapToNewLocation
  global numTiles, tileStartCh, startPt, drag1Ch, drag2Ch
  set speed to 5
  set delta to startPt - endPt
  if abs(getAt(delta, 1)) > abs(getAt(delta, 2)) then
    if getAt(endPt, 1) > getAt(startPt, 1) then
      set xDelta to 1
    else
      set xDelta to -1
    end if
    if getAt(delta, 1) = 0 then
      set yDelta to 0
    else
      set yDelta to float(abs(getAt(delta, 2))) / float(abs(getAt(delta, 1)))
    end if
    if getAt(endPt, 2) < getAt(startPt, 2) then
      set yDelta to yDelta * -1
    end if
    set distance to abs(getAt(delta, 1))
  else
    if getAt(delta, 2) = 0 then
      set xDelta to 0
    else
      set xDelta to float(abs(getAt(delta, 1))) / float(abs(getAt(delta, 2)))
    end if
    if getAt(endPt, 1) < getAt(startPt, 1) then
      set xDelta to xDelta * -1
    end if
    if getAt(endPt, 2) > getAt(startPt, 2) then
      set yDelta to 1
    else
      set yDelta to -1
    end if
    set distance to abs(getAt(delta, 2))
  end if
  if snapToNewLocation = 1 then
    set tempCh to drag2Ch
  else
    set tempCh to drag1Ch
  end if
  swapChannel(tempCh, theTile)
  puppetSound("Move Tile")
  repeat with a = 1 to distance / speed
    set the locH of sprite tempCh to getAt(endPt, 1) - (a * xDelta * speed)
    set the locV of sprite tempCh to getAt(endPt, 2) - (a * yDelta * speed)
    updateCursor()
  end repeat
  set the locH of sprite tempCh to getAt(startPt, 1)
  set the locV of sprite tempCh to getAt(startPt, 2)
  updateCursor()
  swapChannel(theTile, tempCh)
  puppetSound("Click Tile")
  updateStage()
end
